/* 
    Webcam Lab

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2005 Jason Hunt
    nulluser@gmail.com
   
    file: bitmap.cpp
*/


#include "core.h"


/* Save processed frame to a numbered file */
void save_to_disk(void) 
{
    static int next_file_num = 1;

    char filename[100];
    sprintf(filename, "Save to: %d.bmp", next_file_num);
    add_line(filename);

    sprintf(filename, "%d.bmp", next_file_num++);

    HANDLE hf;                 // file handle 

    // bitmap file heared
    BITMAPFILEHEADER hdr;       // bitmap file-header 

    // Createa a pointer to the bitmap info header
    BITMAPINFOHEADER *binfo = &camera_buffer_info.bmiHeader; 

    DWORD dwTotal;              // total count of bytes 
    DWORD cb;                   // incremental count of bytes 
    DWORD tmp; 

    // Create the .BMP file. 
    hf = CreateFile(filename, GENERIC_READ | GENERIC_WRITE, 0, 
                    NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL); 
   
    hdr.bfType = 0x4d42;  // "BM"
      
    // file size
    hdr.bfSize = sizeof(BITMAPFILEHEADER) + binfo->biSize + binfo->biSizeImage; 

    hdr.bfReserved1 = 0; 
    hdr.bfReserved2 = 0; 

    hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + binfo->biSize;

    // save file header
    WriteFile(hf, &hdr, sizeof(BITMAPFILEHEADER), &tmp, NULL);

    // save bitmap info
    WriteFile(hf, (LPVOID) binfo, sizeof(BITMAPINFOHEADER), &tmp, NULL); 

    if (fast_capture)
    {
        // mirror image if we are using fast capture
        for (int y = 0; y < size_y; y++)
        {
            memcpy(temp_frame + (size_y - y - 1) * size_x,
                   camera_buffer + y * size_x, size_x * 4);
        }
     }
    else
        memcpy(temp_frame, camera_buffer,  binfo->biSizeImage); 

    // save image data
    WriteFile(hf, temp_frame, binfo->biSizeImage, &tmp, NULL);

    CloseHandle(hf);
}
/* end of save bitmap */







