/* 
    Webcam Lab

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2005 Jason Hunt
    nulluser@gmail.com
    
    file: main.cpp
*/

#include "core.h"


HWND system_hwnd = NULL;                        // Keep track of application handle

unsigned int frames = 0;                        // Numbers of frames so far in this second
unsigned int fps = 0;                           // Frames per second


/* Runs when window is created */
void system_startup()
{
    add_line("Look at readme.txt for usage");

    camera_start();
        
   // SetTimer(system_hwnd, ID_FRAME , 10, NULL);
    SetTimer(system_hwnd, ID_SECOND, 1000, NULL);
}
/* End of system_startup */


/* Runs when window is closed */
void system_shutdown(void)
{
    destroy_window();

    camera_stop();

    PostQuitMessage(0);   
}
/* End of system_shutdown */

void frame_ready( void )
{
    process_frame();
            
    frames++;

display();

//    InvalidateRect(main_win, 0, true);
}


/* Deal with the system timer */
void timer_message(WPARAM wParam)
{
    if (wParam == ID_FRAME) // Do sample?
    {    


    }   else
    if (wParam == ID_SECOND)
    {
        fps = frames;
        frames = 0;
        
/*        char b[400];
        sprintf(b, "Fps %3d", fps);
        add_line(b);*/
        
    }    
}   
/* End of timer message */


/* Ehe message handler */
LRESULT CALLBACK WinProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)                 
    {
        case WM_CREATE:     system_hwnd = hwnd;;    break;
        case WM_TIMER:      timer_message(wParam); break;
        case WM_DESTROY:    system_shutdown(); break;
        case WM_KEYDOWN:    key_down(wParam); break;
        case WM_KEYUP:      key_up(wParam); break;

        case WM_PAINT:      display();  break;

        case WM_SIZE: 
             display_resize(lParam & 0xffff, lParam >> 16); 
            break;
            
        default: return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return(0);
}
/* End of winproc */


/* Winmain */
int WINAPI WinMain(HINSTANCE hinstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    clear_text_area();
    
    // Make the main window
    if (setup_window(hinstance, nCmdShow)) return(1);

    system_startup();

    MSG messages;

    while (GetMessage (&messages, NULL, 0, 0))
    {
        TranslateMessage(&messages);
        DispatchMessage(&messages);
    }

    return(messages.wParam);
}
/* End of winmain */



