/* 
    Webcam Lab

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2005 Jason Hunt
    nulluser@gmail.com
   
    file: rc_filter.cpp

*/

#include "core.h"


//unsigned int *grad_mag = NULL;
//int *grad_ratio = NULL;


float *image_state = NULL;




/* Get memory for canny edge detection system */
void rc_filter_start( void )
{
    if (image_state != NULL) free(image_state);    

    image_state = (float *) malloc(size_x * size_y * sizeof(float) * 3);
        
    if (image_state  == NULL)
    {            
        add_line("Unable to create image_state buffer");
        return;
    }     
/*
    if (grad_ratio != NULL) free(grad_ratio);    

    grad_ratio = (int *) malloc(size_x * size_y * sizeof(int));
        
    if (grad_ratio  == NULL)
    {            
        add_line("Unable to create grad_ratio buffer");
        return;
    }  */
    
}
/* End of canny start */


/* Free canny memory */
void rc_filter_stop (void )
{
    if (image_state) free(image_state);
}
/* End of canny_stop */





/* Canny edge detection */
void rc_filter(color_type *s, color_type *d)
{
  /*  transform_frame( s, d, gauss_blur, 5, 1/159.0, 0);
*/
    memcpy(d, s, DATA_SIZE);
    
    
    
      unsigned int index = 0;

      unsigned int state_index = 0;


    float r = 0.01;
    

    for (int y = 0; y < size_y; y++)    
    {
        // Skip unused pixel
   
        for (int x = 0; x < size_x; x++)
        {
       
            
//            image_state[state_index++] = s[index].r;
//            image_state[state_index++] = s[index].g;
//            image_state[state_index++] = s[index].b;
                      
                      
              
                      
                      
                      
            image_state[state_index] = s[index].r * r + (1-r) * image_state[state_index];
            image_state[state_index+1] = s[index].g * r + (1-r) * image_state[state_index+1];
            image_state[state_index+2] = s[index].b * r + (1-r) * image_state[state_index+2];
                       
            if (image_state[state_index] < 0) image_state[state_index] = 0;
            if (image_state[state_index] > 255) image_state[state_index] = 255;
            if (image_state[state_index+1] < 0) image_state[state_index+1] = 0;
            if (image_state[state_index+1] > 255) image_state[state_index+1] = 255;
            if (image_state[state_index+2] < 0) image_state[state_index+2] = 0;
            if (image_state[state_index+2] > 255) image_state[state_index+2] = 255;
                       
                       
                       
                       
            d[index].r =  (unsigned char)  image_state[state_index] ;
            d[index].g =   (unsigned char)  image_state[state_index+1] ;
            d[index].b =   (unsigned char)  image_state[state_index+2] ;
                                 
                       
          state_index += 3;
                           index++;
                                         
                
        }
        
        
        
        }
        
      
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
/*
    calulate_gradients(s);

    unsigned int index = 0;

    // Skip unused line
    for (int x = 0; x < size_x; x++)
        d[index++] = black;

    for (int y = 1; y < size_y - 1; y++)    
    {
        // Skip unused pixel
        d[index] = black;
        index++;

        for (int x = 1; x < size_x - 1; x++)
        {
            unsigned int c = 0;
            unsigned int ranged_color = 0;

            // apply threshold
            if (grad_mag[index] > p1)
                c = (int)(grad_mag[index] + 128);

            c = non_maximal(index, c);

            // clamp
            if (c > 255) c = 255;
            if (c < 0) c = 0;

            // If the edge passed the threshold, set the pixel red
            // Otherwise set it to the value form the starting frame
            if (c == 0)
                d[index] = save_frame[index];
            else
                d[index] = red;
                    
            index++;
        }

        // Skip unused pixel;
        d[index] = black;
        index++;                
    }
    
    // Skip unused line
    for (int x = 0; x < size_x; x++)
        d[index++] = black;*/
        
        
}
/* End of canny_edge */

